      program cookie
      common last, fortune, user
      character *160 fortune
      character *12 user
      character *20 q(4), p(4), string
c
      call getfor ( nq, q, np, p )
      open (unit=1,access='direct',carriagecontrol='none',
     $  file='sys$system:fortunes.dat',recl=44,form='unformatted',
     $  organization='sequential',recordtype='fixed',
     $  readonly,status='old')
      open(unit=5,file='sys$input:')
      open(unit=6,file='sys$output:')

      read (1,rec=1,err=1000) last
      if (nq .eq. 0) then
c
c --- cookie
c
         call random(x)
         i = x*(last-1) + 2.
         call cookout(i,.false.)
      else if (q(1)(1:1) .eq. 'A') then
c
c --- cookie/add
c
         call add ( last )
      else if (q(1)(1:1) .eq. 'D') then
c
c --- cookie/delete
c
         call del
      else if (q(1)(1:1) .eq. 'F') then
c
c --- cookie/find
c
         i = 0
         ifind = 0
         write(6,990)
990      format(' Search string: ',$)
         read(5,900) string
         call caps(string)
70       call find ( i, string )
         if (i .le. last) then
            call cookout ( i, .true. )
            ifind = ifind + 1
         endif
         write(6,*) ' '
         if (i .lt. last) go to 70
         if (ifind .eq. 0) write(6,*)'No match.'
      else if (q(1)(1:1) .eq. 'L') then
c
c --- cookie /list or /last
c
         write(6,*)last,' fortunes.'
         istart = 2
         if (q(1)(2:2) .eq. 'A') istart = max0(last - 19, 2)
         do 100 i=istart,last
            call cookout ( i, .true. )
            write(6,*) ' '
100         continue      
      else if (q(1)(1:1) .eq. 'Z') then
c
c --- cookie/Z  (last 20 cookies)
c
         j = last - 19
         do 200 i = j, last
            call cookout ( i, .true. )
            write(6,*) ' '
200         continue
      else
         call error('ILLQUAL, Illegal qualifier.')
      endif
      close (1)
      call exit (1)
1000  call error('ARGH, Unable to read fortunes file.')
900   format(a)
      end
c
c
c
      subroutine cookout ( i, show_user )
      character *160 fortune
      character *12 user
      integer uic(2)
      logical show_user, show_num
c
      read(1,rec=i) fortune, user
      k = leng(fortune)
c      if (k .gt. 80) then
c         j = 81
c10       j = j - 1
c         if ((j .gt. 40) .and. (fortune(j:j) .ne. ' ') .and.
c     $       (fortune(j:j) .ne. char(10))) go to 10
c         write(6,*) fortune(1:j)
c         write(6,*) fortune(j+1:k)
c      else
c         write(6,*) fortune(1:k)
c      endif
      istat = lib$put_output ( fortune(1:k) )
      if (show_user) write(6,*) user, i
      return
      end
c
c
c
      subroutine random ( x )
      x = secnds(0.0) * 3.0
      i = x
      i = mod(i,1000)
      x = float(i)/1000.0
      return
      end
c
c
c 
      function leng(f)
      character *(*) f
c
      do 100 leng = 160, 1, -1
        ic = ichar(f(leng:leng))
        if ((ic .ne. 0) .and. (ic .ne. 32)) return
 100    continue
      return
      end
c
c
c
      subroutine error(string)
      character *(*) string
c
      write(6,*)'%COOKIE-F-'//string
      call exit
      end
c
c
c
      subroutine find ( i, string )
      character *(*) string
      common last, fortune, user
      character *172 temp
      character *160 fortune
      character *12 user
c
      ls = length(string)
      if (ls .eq. 0) ls = 1
10    i = i + 1
      read(1,rec=i)fortune,user
      temp = fortune//user
      call caps(temp)
      if (index(temp,string(1:ls)) .ne. 0) return
      if (i .lt. last) go to 10   
      i = i + 1
      return
      end
c
c
c
      subroutine add ( last )
      character *160 fortune, line
      character *12 user, us
c
      open(unit=2,status='old',file='sys$system:blacklist.dat',
     $     readonly)
      call getuser ( user )
10    read(2,900,end=20) us
      if ( us .eq. user ) then
         call error('NOWAYBUSTER, you have been blacklisted.')
      endif
      go to 10
20    close(unit=1)
      open (unit=1,access='direct',carriagecontrol='none',
     $  file='sys$system:fortunes.dat',recl=43,form='unformatted',
     $  organization='sequential',recordtype='fixed',
     $  status='old')
      write(6,*)'Enter cookie (160 characters max), ^Z to exit.'
      l = 1
30    read(5,910,end=40) n,line
      if (l .gt. 1) then         ! end of previous line
         fortune(l:l+1) = char(13)//char(10)
         l = l + 2
      endif
      if ((l+n) .gt. 160) then
         call error('TOOLONG, cookie limited to 160 characters.')
      endif
      if (n .gt. 79) then
         j = 80
35       j = j - 1
         if ((j .gt. 40) .and. (line(j:j) .ne. ' ')) go to 35
         fortune(l:l+j) = line(1:j-1)//char(13)//char(10)
         l = l + j + 1
         fortune(l:) = line(j+1:n)
         l = l + n - j 
      else
         fortune(l:l+n) = line(1:n)
         l = l + n
      endif
      go to 30
40    last = last + 1
      write(1,rec=last,err=100) fortune,user
      write(1,rec=1,err=100) last
      return
100   call error('NOUPDATE, unable to update fortunes file.')
900   format(a)
910   format(q,a)
      end
c
c
c
      subroutine del
      common last, fortune, user
      character *160 fortune
      character *12 user, us, yes
      character *20 string
      character *6 privs(40)
      logical sysprv
c
      call getcprv ( n, privs )
      sysprv = .false.
      do 5 i=1,n
         if (privs(i) .eq. 'SYSPRV') sysprv = .true.
5        continue
c
c get search string
      write(6,*)'Enter search string '
      read(5,900) string
      call caps ( string )
      i = 0
      call getuser ( us )
      close (1)
      open (unit=1,access='direct',carriagecontrol='none',
     $  file='sys$system:fortunes.dat',recl=43,form='unformatted',
     $  organization='sequential',recordtype='fixed',
     $  status='old')
      idel = 0
10    call find ( i, string )
      if (i .gt. last) go to 25
      if (sysprv .or. (us .eq. user)) then
         call cookout ( i, .false. )
         write(6,990)
990      format(' Delete ? (Y/N/^Z)',$)
         read(5,900,end=25) yes
         if ((yes(1:1) .eq. 'y') .or. (yes(1:1) .eq. 'Y')) then
            if (i .lt. last) then
               read(1,rec=last) fortune, user
               write(1,rec=i) fortune, user
            endif
            last = last - 1
            write(1,rec=1) last
            idel = idel + 1
            i = i - 1                ! Recheck this cookie
         endif
      endif
      if (i .lt. last) go to 10
25    write(6,*) idel, ' cookies deleted.'
      return
900   format(a)
      end
